/******************************************************************************
 * * Archivo: ser_prime.c
 * * DESCRIPCION: Calcula el nmero primo mayor de un nmero dado(LIMIT) por 
 * *    fuerza bruta e indica cuantos nmeros primos existen en este rango.
 * * EVENTO: Congreso Nacional de Software Libre 2004(CONSOL) www.consol.org.mx/2004/
 * * PONENTES:
 * *    Castillo Castillo Jos - www.josecc.net
 * *    Ricardo Benjamn Olvera Acosta
 * *    Jeanette Moreno Snchez.
 * * AUTHOR: Blaise Barney 11/25/95 - adapted from version contributed by 
 * *    Richard Ng & Wong Sze Cheong during MHPCC Singapore Workshop (8/22/95).
 * * URL: http://www.columbia.edu/itc/applied/e6901/
 * * NOTA: Slo se utiliza este cdigo como ejemplo de demostracin. Se ha modificado
 * *    algunas lneas con fines didacticos, puede encontrar el cdigo original en
 * *    el sitio antes referido.
 * ****************************************************************************/

#include <stdio.h>
#include <math.h>

#define LIMIT     2500000*10     /* Incremente para calcular un nmero primo mayor*/
#define PRINT     100000      /* Imprime una lnea despues de PRINT iteraciones */


int isprime(int n) {
  int i,squareroot;
  if (n>10) {
    squareroot = (int) sqrt(n);
    for (i=3; i<=squareroot; i=i+2)
      if ((n%i)==0)
	return 0;
    return 1;
  }
  /* Assume first four primes are counted elsewhere. Forget everything else */
  else
    return 0;
}


int main(void) {
  int n,                         /* loop variables */
    pc,                          /* prime counter */
    foundone;                    /* most recent prime found */

  printf("Iniciando. Nmeros a buscar hasta %d\n",LIMIT);

  pc=4;     /* Assume the primes less than 10 (2,3,5,7) are counted here */

  for (n=11; n<=LIMIT; n=n+2) {
    if (isprime(n)) {
      pc++;
      foundone = n;
      /***** Opcional: imprime el nmero primo encontrado
       *       printf("%d\n",foundone);
       *             *****/
    }                 
    if ( (n-1)%PRINT == 0 ) 
      printf("Nmeros buscados: %d   Nmeros primos enconrados: %d\n",n-1,pc);
  }
  printf("Finalizado. El nmero primo mayor encontrado: %d Total de nmeros primos: %d\n",foundone,pc);
  return 0;
} 

