#include "utility.h"
#include "configuration.h"

#define KEY_POVRAY_PATH    "/SETTINGS/POVRAYPATH"
#define KEY_ATTRIBUTE_LIST "/SETTINGS/ATTRIBUTELIST"
#define KEY_TMP_DIR        "/SETTINGS/TMPDIR"
#define KEY_DEFAULT_JOBS   "/SETTINGS/DEFAULTJOBS"
#define KEY_DEFAULT_W      "/SETTINGS/DEFAULTW"
#define KEY_DEFAULT_H      "/SETTINGS/DEFAULTH"


// --------------------------------------------------------------------------------  
CFG::CFG(void)
{ 
}

// --------------------------------------------------------------------------------
bool CFG::setPovrayPath(const QString &path)
{ 
  bool ret = m_qs.writeEntry(KEY_POVRAY_PATH,path);
  
  if(!ret) CERR("Cannot set povray path !\n");
  
  return(ret);
}

// --------------------------------------------------------------------------------
QString CFG::getPovrayPath(void)
{ 
  bool ok;
  
  QString povrayPath = m_qs.readEntry(KEY_POVRAY_PATH,"/usr/local/bin/povray",&ok);
  
  return(povrayPath);
}

// --------------------------------------------------------------------------------
bool CFG::setAttributeList(const QString &attrList)
{ 
  bool ret = m_qs.writeEntry(KEY_ATTRIBUTE_LIST,attrList);
  
  if(!ret) CERR("Cannot set attribute list !\n");
  
  return(ret);
}

// --------------------------------------------------------------------------------
QString CFG::getAttributeList(void)
{ 
  bool ok;
  
  QString attrList = m_qs.readEntry(KEY_ATTRIBUTE_LIST,"",&ok);
  
  return(attrList);
}

// --------------------------------------------------------------------------------
bool CFG::setTmpDir(const QString &dir)
{ 
  bool ret = m_qs.writeEntry(KEY_TMP_DIR,dir);
  
  if(!ret) CERR("Cannot set temp. directory !\n");
  
  return(ret);
}

// --------------------------------------------------------------------------------
QString CFG::getTmpDir(void)
{ 
  bool ok;
  
  QString tmpDir = m_qs.readEntry(KEY_TMP_DIR,"/tmp",&ok);
  
  return(tmpDir);
}

// --------------------------------------------------------------------------------
bool CFG::setDefaultJobs(int jobs)
{ 
  bool ret = m_qs.writeEntry(KEY_DEFAULT_JOBS,STRING(jobs));
  
  if(!ret) CERR("Cannot set default jobs !\n");
  
  return(ret);
}

// --------------------------------------------------------------------------------
int CFG::getDefaultJobs(void)
{ 
  bool ok;
  
  QString defJob = m_qs.readEntry(KEY_DEFAULT_JOBS,"4",&ok);
  
  return(INT(defJob));
}

// --------------------------------------------------------------------------------
int CFG::getDefaultW(void)
{
  bool ok;
  
  QString defW = m_qs.readEntry(KEY_DEFAULT_W,"1024",&ok);
  
  return(INT(defW));
}
 
// --------------------------------------------------------------------------------
int CFG::getDefaultH(void)
{
  bool ok;
  
  QString defH = m_qs.readEntry(KEY_DEFAULT_H,"768",&ok);
  
  return(INT(defH));
}

// --------------------------------------------------------------------------------
bool CFG::setDefaultW(int W)
{ 
  bool ret = m_qs.writeEntry(KEY_DEFAULT_W,W);
  
  return(ret);
}
  
// --------------------------------------------------------------------------------
bool CFG::setDefaultH(int H)
{ 
  bool ret = m_qs.writeEntry(KEY_DEFAULT_H,H);
  
  return(ret);
}
