/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void Form1::SLOT_configure()
{
  Form2 *w = new Form2;
  
  // Read configuration
  w->lineEdit1->setText(m_cfg.getPovrayPath());
  w->lineEdit2->setText(m_cfg.getAttributeList());
  w->lineEdit3->setText(m_cfg.getTmpDir());
  w->spinBox2->setValue(m_cfg.getDefaultJobs());
  w->spinBox3->setValue(m_cfg.getDefaultW());
  w->spinBox4->setValue(m_cfg.getDefaultH());
  
  if(w->exec() == QDialog::Accepted)
  {
    m_cfg.setPovrayPath(w->lineEdit1->text()); 
    m_cfg.setAttributeList(w->lineEdit2->text());
    m_cfg.setTmpDir(w->lineEdit3->text());
    m_cfg.setDefaultJobs(w->spinBox2->value());
    m_cfg.setDefaultW(w->spinBox3->value());
    m_cfg.setDefaultH(w->spinBox4->value());
  }
}


void Form1::SLOT_createTask()
{
  Form3 *w = new Form3;
  
  w->lineEdit5->setText(m_cfg.getAttributeList());
  w->spinBox2->setValue(m_cfg.getDefaultJobs());
  w->spinBox4->setValue(m_cfg.getDefaultW());
  w->spinBox5->setValue(m_cfg.getDefaultH());
  
  if(w->exec() == QDialog::Accepted)
  {
    QString inputFile     = w->lineEdit1->text();
    QString outputFile    = w->lineEdit2->text();
    QString outputType    = w->comboBox1->currentText();
    QString attributeList = w->lineEdit5->text();
    int    jobs           = w->spinBox2->value();
    int    width          = w->spinBox4->value();
    int    height         = w->spinBox5->value();

    
    QString err;
    TASK *ret = TASK::createTask(err,m_cfg.getPovrayPath(),inputFile,outputFile,outputType,attributeList,m_cfg.getTmpDir(),width,height,jobs);
    
    if(!err.isEmpty())
    {
      QMessageBox::warning(this, 
                           "TASK creation error !",
                           err,
                           QMessageBox::Ok | QMessageBox::Default,
                           QMessageBox::NoButton);
      
      return;
    }
    
    ret->validateTASK();
    
    QString sJobs   = STRING<int>(ret->getJobs());
    QString sTaskN  = STRING<int>(ret->getTaskN());
    QString sStatus = ret->getTaskStatusStr();
    QString size    = STRING(width) + "x" + STRING(height);
    
    QListViewItem *i = new QListViewItem(listView1,
                                         sTaskN,
                                         sJobs,
                                         size,
                                         ret->getInputFile(),
                                         ret->getOutputFile(),
                                         sStatus);
    
    ret->setItem(i);
    }
    
  delete w;
}


void Form1::init()
{
  M_JOBLIST=0;
  M_SELECTED_TASK = 0;
  M_SELECTED_JOB = 0;
  ACT_editTask->setEnabled(false);
  ACT_removeTask->setEnabled(false);
  ACT_preview->setEnabled(false);
  ACT_start->setEnabled(false);
  ACT_pause->setEnabled(false);
  ACT_stop->setEnabled(false);
  ACT_viewOutput->setEnabled(false);
  
  // Openmosix
  if(!m_openMosix.isOk())
  {
    QMessageBox::warning(this, 
                         "OPENMOSIX ENVIROMENT CHECK",
                         "Openmosix environment not found !, please check openmosix installation\nOpenmosix related functions will be disabled.",
                         QMessageBox::Ok | QMessageBox::Default,
                         QMessageBox::NoButton);
                         
    ACTG_openmosix->setEnabled(false);
  }
}


void Form1::SLOT_listview1SelectionChanged( QListViewItem *i)
{
  // Clear list
  listView2->clear();
  
  M_SELECTED_JOB=0;  
  if(M_SELECTED_TASK) M_SELECTED_TASK->resetAllItems();
  
  M_SELECTED_TASK = TASK::findTask(INT(i->text(0)));
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : task not found in task list !\n");
    return;
  }
  
  if(M_SELECTED_TASK->getTaskStatusStr()=="QUEUED")
  {    
    ACT_viewOutput->setEnabled(false);
    ACT_editTask->setEnabled(true);
    ACT_removeTask->setEnabled(true);    
    ACT_start->setEnabled(true);
    ACT_pause->setEnabled(false);
    ACT_pause->setOn(false);
    ACT_stop->setEnabled(false);
    ACT_preview->setEnabled(false);
  }
  else if(M_SELECTED_TASK->getTaskStatusStr()=="RUNNING")
  {    
    ACT_viewOutput->setEnabled(false);
    ACT_editTask->setEnabled(false);
    ACT_removeTask->setEnabled(false);    
    ACT_start->setEnabled(false);
    ACT_pause->setEnabled(true);
    ACT_pause->setOn(false);
    ACT_stop->setEnabled(true);
    ACT_preview->setEnabled(true);
  }
  else if(M_SELECTED_TASK->getTaskStatusStr()=="PAUSED")
  {    
    ACT_viewOutput->setEnabled(false);
    ACT_editTask->setEnabled(false);
    ACT_removeTask->setEnabled(false);    
    ACT_start->setEnabled(false);
    ACT_pause->setEnabled(true);
    ACT_pause->setOn(true);
    ACT_stop->setEnabled(true);
    ACT_preview->setEnabled(false);
  }
  else if(M_SELECTED_TASK->getTaskStatusStr()=="FINISHED")
  { 
    ACT_viewOutput->setEnabled(false);   
    ACT_editTask->setEnabled(true);
    ACT_removeTask->setEnabled(true);    
    ACT_start->setEnabled(true);
    ACT_pause->setEnabled(false);
    ACT_pause->setOn(false);
    ACT_stop->setEnabled(false);
    ACT_preview->setEnabled(true);
  }    
  else
  {    
    ACT_viewOutput->setEnabled(false);
    ACT_editTask->setEnabled(false);
    ACT_removeTask->setEnabled(false);    
    ACT_start->setEnabled(false);
    ACT_pause->setEnabled(false);
    ACT_pause->setOn(false);
    ACT_stop->setEnabled(false);
    ACT_preview->setEnabled(false);
  }
  
  // Show jobs
  QValueList<JOB *> jobsList = M_SELECTED_TASK->getJobList();
  for(QValueList<JOB *>::iterator i=jobsList.begin();i!=jobsList.end();i++)
  {
    QString jobNumberStr = STRING((*i)->getJobNumber());
    QString startStr     = STRING((*i)->getStart());
    QString endStr       = STRING((*i)->getEnd());
    QString statusStr    = (*i)->getJobStatusStr();
    QString tmpFile      = (*i)->getTempFile();
    QString perc         = (*i)->getPerc();
    
    QListViewItem *item = new QListViewItem(listView2,jobNumberStr,startStr,endStr,tmpFile,statusStr,perc);
    
    (*i)->setItem(item);

    if((*i)->getExitStatus())
    {
      QImage img = QImage::fromMimeSource("error.png");
      item->setPixmap(0,img);
    } else item->setPixmap(0,QImage());  
        
  }
}


void Form1::SLOT_startRendering()
{
    
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : task not found in task list !\n");
    return;
  }
 
  ACT_start->setEnabled(false);
  ACT_pause->setEnabled(true);
  ACT_stop->setEnabled(true);
  ACT_removeTask->setEnabled(false);

  if(!M_SELECTED_TASK->isAnimation())
  {
    bool ret = M_SELECTED_TASK->run();
    if(!ret)
    {
      QMessageBox::warning(this, 
                           "START RENDERING ERROR !",
                           "Check povray path in configuration dialog",
                           QMessageBox::Ok | QMessageBox::Default,
                           QMessageBox::NoButton);    
    
      ACT_start->setEnabled(true);
      ACT_pause->setEnabled(false);
      ACT_stop->setEnabled(false);
      ACT_removeTask->setEnabled(true);
    }
  } else {
            Form9 *w = new Form9;
            
            w->spinBox1->setMinValue(0);
            w->spinBox2->setMinValue(0);
            w->spinBox1->setMaxValue(M_SELECTED_TASK->getFirstFrame() == 0 ? M_SELECTED_TASK->getLastFrame() + 1 : M_SELECTED_TASK->getLastFrame());
            w->spinBox2->setMaxValue(M_SELECTED_TASK->getFirstFrame() == 0 ? M_SELECTED_TASK->getLastFrame() + 1 : M_SELECTED_TASK->getLastFrame());
            w->spinBox2->setValue(M_SELECTED_TASK->getFirstFrame() == 0 ? M_SELECTED_TASK->getLastFrame() + 1 : M_SELECTED_TASK->getLastFrame());
            
            if(w->exec() == QDialog::Accepted)
            {  
              int start = w->spinBox1->value();
              int end   = w->spinBox2->value();

              if(start>end)
              {
                int tmp = start;

                start = end;
                end   = tmp;
              }

              bool ret = M_SELECTED_TASK->runAnimation(start,end);
              if(!ret)
              {
                QMessageBox::warning(this, 
                                     "START RENDERING ERROR !",
                                     "Check povray path in configuration dialog",
                                     QMessageBox::Ok | QMessageBox::Default,
                                     QMessageBox::NoButton);    
    
                ACT_start->setEnabled(true);
                ACT_pause->setEnabled(false);
                ACT_stop->setEnabled(false);
                ACT_removeTask->setEnabled(true);
              }
            } else {
                      ACT_start->setEnabled(true);
                      ACT_pause->setEnabled(false);
                      ACT_stop->setEnabled(false);
                      ACT_removeTask->setEnabled(true);
                    }
          }
}


void Form1::SLOT_listView2SelectionChanged( QListViewItem *i )
{
  
  M_SELECTED_JOB = 0;
  
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : task not found in task list !\n");
    return;
  }
  
  M_SELECTED_JOB = M_SELECTED_TASK->findJob(INT(i->text(0)));
  if(!M_SELECTED_JOB)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }
  
  if(M_SELECTED_JOB->getJobStatusStr()=="FINISHED") ACT_viewOutput->setEnabled(true);
}


void Form1::SLOT_viewJobOutput()
{
  if(!M_SELECTED_JOB)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }
  
  Form4 *w = new Form4;
  
  w->textEdit1->setText(M_SELECTED_JOB->getStdErr());
  w->show();
}


void Form1::SLOT_editTask()
{

  if(!M_SELECTED_TASK)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }

  Form3 *w = new Form3;

  w->lineEdit1->setText(M_SELECTED_TASK->getInputFile());
  w->lineEdit2->setText(M_SELECTED_TASK->getOutputFile());
  w->lineEdit5->setText(M_SELECTED_TASK->getAttributeList());
  w->spinBox2->setValue(M_SELECTED_TASK->getJobs());
  w->spinBox4->setValue(M_SELECTED_TASK->getWidth());
  w->spinBox5->setValue(M_SELECTED_TASK->getHeight());
  w->comboBox1->setCurrentText(M_SELECTED_TASK->getOutputType());
  
  w->m_task = M_SELECTED_TASK;
  
  if(w->exec() == QDialog::Accepted)
  {
    QString inputFile     = w->lineEdit1->text();
    QString outputFile    = w->lineEdit2->text();
    QString attributeList = w->lineEdit5->text();
    QString outputType    = w->comboBox1->currentText();
    int     jobs          = w->spinBox2->value();
    int     width         = w->spinBox4->value();
    int     height        = w->spinBox5->value();

    M_SELECTED_TASK->setInputFile(inputFile);
    M_SELECTED_TASK->setOutputFile(outputFile);
    M_SELECTED_TASK->setAttributeList(attributeList);
    M_SELECTED_TASK->setJobs(jobs);
    M_SELECTED_TASK->setWidth(width);
    M_SELECTED_TASK->setHeight(height);
    M_SELECTED_TASK->setOutputType(outputType);
  }
  
  // Recreate jobs
  QString error;
  M_SELECTED_TASK->recreateJobs(error);
  if(!error.isEmpty())
  {  
    QMessageBox::warning(this, 
                         "TASK creation error !",
                         error,
                         QMessageBox::Ok | QMessageBox::Default,
                         QMessageBox::NoButton);
  }   
  
  if(M_SELECTED_TASK->getItem())
  {
    M_SELECTED_TASK->updateItem();
    SLOT_listview1SelectionChanged(M_SELECTED_TASK->getItem());
  }
  
  delete w;
}


void Form1::SLOT_deleteTask()
{
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }

  QListViewItem *item = M_SELECTED_TASK->getItem();
  if(item) delete item;
  
  TASK::deleteTask(M_SELECTED_TASK);
  
  listView2->clear();
  init();
}


void Form1::destroy()
{
  M_SELECTED_TASK=0;
  M_SELECTED_JOB=0;
  
  TASK::deleteAllTasks();
}


void Form1::SLOT_preview()
{
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }

  if(!M_SELECTED_TASK->isAnimation())
  {
    Form5 *w = new Form5;
  
    QImage img;
  
    img.load(M_SELECTED_TASK->getOutputFile(),QString(M_SELECTED_TASK->getOutputType()).upper());
  
    if(img.isNull())
    {
      CERR("Warning : error opening output file !\n");
      return;
    }

    w->resize(img.width(),img.height());
  
    /*
    img = img.scale(w->width(),w->height());  
    QPixmap pixmap(img);
    */
  
    w->setBackgroundPixmap(img);
    
    w->show();
  } else {
            Form10 *w = new Form10;
             
            w->spinBox1->setMinValue(M_SELECTED_TASK->getFirstFrame());
            w->spinBox1->setMaxValue(M_SELECTED_TASK->getLastFrame());
            w->spinBox1->setValue(M_SELECTED_TASK->getFirstFrame());
            
            if(w->exec() == QDialog::Accepted)
            {
              JOB *j = M_SELECTED_TASK->getJobFrame(w->spinBox1->value());
              
              if(!j)
              {
                CERR("Warning : frame not found in job list !\n");
                return;
              }
              
              if(j->getExitStatus()!=0 || j->getJobStatusStr()!="FINISHED")
              {
                QMessageBox::warning(this, 
                                    "FRAME display error !",
                                    "Render frame first.",
                                    QMessageBox::Ok | QMessageBox::Default,
                                    QMessageBox::NoButton);
                                    
                return;
              }
              
              QImage img;
  
              img.load(j->getRealOutputName(),"PPM");
  
              if(img.isNull())
              {
                CERR("Warning : error opening output file !\n");
                return;
              }

              Form5 *w1 = new Form5;
                  
              w1->resize(img.width(),img.height());
  
              w1->setBackgroundPixmap(img);
    
              w1->show();
            }
          }
}


void Form1::SLOT_openmosixInfo()
{
  Form6 *w = new Form6;
  
  w->exec();
}


void Form1::SLOT_showJobList()
{
  if(!M_JOBLIST) M_JOBLIST = new Form7;
  
  M_JOBLIST->showList();  
  M_JOBLIST->show();
}


void Form1::SLOT_open()
{
  QString s = QFileDialog::getOpenFileName(
                    QString::null,
                    "Povmosix (*.povmosix);;All (*)",
                    this,
                    "Open POVmosix file"
                    "Choose a file" );
                    
  if(!s.isEmpty())
  {
    M_SELECTED_TASK = 0;
    M_SELECTED_JOB  = 0;
    
    TASK::deleteAllTasks();
    listView1->clear();
    listView2->clear();
    loadTASKS(this,listView1,(const char *) s);
  }
}


void Form1::SLOT_save()
{
  QString s = QFileDialog::getSaveFileName(
                    QString::null,
                    "Povmosix (*.povmosix);;All (*)",
                    this,
                    "Choose the output file"
                    "Choose a file" );
                    
  if(!s.isEmpty()) saveTASKS(this,(const char *) s);
}


void Form1::SLOT_stopTask()
{
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }
  
  if(M_SELECTED_TASK->getTaskStatusStr()!="RUNNING" && M_SELECTED_TASK->getTaskStatusStr()!="PAUSED")
  {
    CERR("Warning : job is not running !\n");
    return;
  }  
  
  M_SELECTED_TASK->stopTask();
}


void Form1::SLOT_about()
{
  Form8 *w = new Form8;

  w->exec();
}


void Form1::SLOT_pause(bool t)
{
  if(t) CERR("ON\n");
   else CERR("OFF\n");
   
  if(!M_SELECTED_TASK)
  {
    CERR("Warning : job not found in task list !\n");
    return;
  }
  
  if(M_SELECTED_TASK->getTaskStatusStr()!="RUNNING" && M_SELECTED_TASK->getTaskStatusStr()!="PAUSED")
  {
    CERR("Warning : job is not running !\n");
    return;
  }  
  
  if(M_SELECTED_TASK->getTaskStatusStr()=="RUNNING" && (!t))
  {
    CERR("Invalid 1 !\n");
    return;
  }  

  if(M_SELECTED_TASK->getTaskStatusStr()=="PAUSED" && (t))
  {
    CERR("Invalid 2 !\n");
    return;
  }  
    
  
  if(ACT_pause->isOn()) M_SELECTED_TASK->pauseTask();
                   else M_SELECTED_TASK->continueTask();
                   
}

