/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void Form2::SLOT_getDirectory()
{
 QString s = QFileDialog::getExistingDirectory(
                    lineEdit3->text(),
                    this,
                    "Get existing directory."
                    "Choose a directory");
                    
  if(!s.isEmpty()) lineEdit3->setText(s);
}


void Form2::SLOT_ok()
{
  if(lineEdit1->text().isNull())
  {
    QMessageBox::critical(this, 
                          "Configuration error !",
                          "Insert the povray path.",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);    
    
    return;
  }

  // Check the povray path  
  QFileInfo f(lineEdit1->text());
  
  if(!f.exists())
  {
    QMessageBox::critical(this, 
                          "Configuration error !",
                          "Cannot found povray path.",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);    
    
    return;
  }    
  
  if(!f.isExecutable())
  {
    QMessageBox::critical(this, 
                          "Configuration error !",
                          "Povray path point to a non executable file",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);    
    
    return;
  }    
  
  // Check temp directory
  QFileInfo f1(lineEdit3->text());
  
  if(!f1.isDir())
  {
    QMessageBox::critical(this, 
                          "Configuration error !",
                          "Cannot open temp. directory.",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);    
    
    return;
  }    
  
  accept();
}


void Form2::SLOT_povPath()
{
  QString s = QFileDialog::getOpenFileName(
                    lineEdit1->text(),
                    QString::null,
                    this,
                    "Find povray executable"
                    "Choose a file" );
    
  lineEdit1->setText(s);
}
