/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void Form3::SLOT_openPovFile()
{
  QString s = QFileDialog::getOpenFileName(
                    lineEdit1->text(),
                    "Pov (*.pov);;All (*)",
                    this,
                    "Open pov file"
                    "Choose a file" );
                    
  if(!s.isEmpty()) lineEdit1->setText(s);
}


void Form3::SLOT_openOutFile()
{
  QString s = QFileDialog::getSaveFileName(
                    lineEdit2->text(),
                    "Images (*.png *.xpm *.jpg *.tga *.bmp);;All (*)",
                    this,
                    "Choose the output file"
                    "Choose a file" );

  lineEdit2->setText(s);
}


void Form3::SLOT_ok()
{
  // Check
  if(lineEdit1->text().isEmpty())
  {
    QMessageBox::critical(this, 
                          "Error",
                          "Please insert the input file name.",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);
      
    return;    
  }
  
  if(lineEdit2->text().isEmpty())
  {
    QMessageBox::critical(this, 
                          "Error",
                          "Please insert the output file name.",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);
      
    return;    
  }  
 
  QFileInfo fInfo(lineEdit1->text());
  if(!fInfo.exists())
  {
    QMessageBox::critical(this, 
                          "Error",
                          "Input file doesent exist.",
                          QMessageBox::Ok | QMessageBox::Default,
                          QMessageBox::NoButton);
      
    return;    
  }  

  // Check output file in other task
  const QValueList<TASK *> taskList = TASK::getTaskList();
  for(QValueList<TASK *>::const_iterator t=taskList.begin();t!=taskList.end();t++)
  {
    if((*t)==m_task) continue;
    
    if((*t)->getOutputFile()==lineEdit2->text())
    {
      QMessageBox::critical(this, 
                            "Error",
                            "Output file just present in another task.\nPlease change the output filename.",
                            QMessageBox::Ok | QMessageBox::Default,
                            QMessageBox::NoButton);
                         
      return;
    }
  }

  // Check output file existance
  if(QFile::exists(lineEdit2->text()))
  {
    QString str = QString("File ") + lineEdit2->text() + QString(" already exists\n Delete it ?");
      
    int ret = QMessageBox::warning(this, 
                                  "Warning",
                                   str,
                                   QMessageBox::Ok,
                                   QMessageBox::Cancel | QMessageBox::Default);
      
    if(ret == QMessageBox::Cancel) return;
    
    QFile::remove(lineEdit2->text());
  }
    
  if(comboBox1->currentText()=="auto")
  {
    QString format;
    bool    ret = imageBuilder::checkOutputFormat(lineEdit2->text(),format);
    if(!ret)
    {
      QMessageBox::warning(this, 
                           "Output type error !",
                           "Unknown output type format, please insert a valid output file extension (i.e. file.png)",
                           QMessageBox::Ok | QMessageBox::Default,
                           QMessageBox::NoButton);
        return;
      }

      comboBox1->setCurrentText(QString(format).upper());
  }
  
  accept();
}


void Form3::init()
{
  m_task = 0;

  // Add output formats
  QValueList<QString> outputF = imageBuilder::getSupportedOutputFormats();

  for(QValueList<QString>::iterator i=outputF.begin();i!=outputF.end();i++)
  {
    comboBox1->insertItem((*i).upper());
  }
}

