#ifndef IMAGE_H
#define IMAGE_H

#include <qvaluelist.h>
#include <qstring.h>

#include <qimage.h>
#include "job.h"



class imageBuilder
{
  private:
  
  QImage m_img;

  QImage buildJobImage(bool &err,JOB *job);
  
  public:
  
  bool                       buildImage(int w,int h,QValueList<JOB *> &jobsList);
  bool                       buildImage(int w,int h,JOB *job);
  static QValueList<QString> getSupportedOutputFormats(void);
  static bool                checkOutputFormat(const QString &outputFormat,QString &format);
  bool                       saveImage(const QString &filename,const QString &type);
};

#endif
