#ifndef OPENM_H
#define OPENM_H

#include <qstring.h>
#include <qvaluelist.h>



typedef struct _NODEINFO
{
  int m_id;
  int m_cpus;
  int m_load;
  int m_mem;
  int m_tmem;
  int m_speed;
  int m_status;
    
  _NODEINFO() : m_id(0),m_cpus(0),m_load(0),m_mem(0),m_tmem(0),m_speed(0),m_status(0) {}
} NODEINFO;


class openMosixWrapper
{
  private:

  bool                 m_isOk;
  int                  m_nodeId;
  bool                 m_autoMigration;
  QValueList<QString>  m_nodes;
  QValueList<NODEINFO> m_nodesData;
  QString              m_info;
  
  int     getId(void);
  bool    getAM(void);
  void    getNodes(void);
  void    getNodesData(void);
  QString getInfo(void);  

  
  public:

  openMosixWrapper(void);
  
  int isOk(void) const;
  
  // GET
  int                          getNodeId(void) const        {return(m_nodeId);}
  bool                         getAutoMigration(void) const {return(m_autoMigration);}
  const QValueList<NODEINFO> & getNodeData(void) const      {return(m_nodesData);}
  QString                      getNodeInfo(void) const      {return(m_info);}
  
  static int where(int pid);
};

#endif
